
MAC="00:00:00:00:00:00"
MAC_DIR="/vendor/wifi"
MAC_PATH="$MAC_DIR/softmac"


read_mac_otp()
{
  local mac="00:00:00:00:00:00"

  mac0=$(busybox printf "0x%08x\n" $(cat /sys/fsl_otp/HW_OCOTP_MAC0))
  mac1=$(busybox printf "0x%08x\n" $(cat /sys/fsl_otp/HW_OCOTP_MAC1))
  
  m1=$(echo $mac0 | busybox cut -b 9-10)
  m2=$(echo $mac0 | busybox cut -b 7-8)
  m3=$(echo $mac0 | busybox cut -b 5-6)
  m4=$(echo $mac0 | busybox cut -b 3-4)
  m5=$(echo $mac1 | busybox cut -b 9-10)
  m6=$(echo $mac1 | busybox cut -b 7-8)
  
  mac="$m6:$m5:$m4:$m3:$m2:$m1"
  MAC=$mac
  return 0
}

[ -f $MAC_PATH ] && softmac=$(cat $MAC_PATH)

if [ "-$softmac-" = "--" ]; then
	read_mac_otp
	if [ ! "$MAC" = "00:00:00:00:00:00" ]; then
	  [ -e $MAC_DIR ] || mkdir $MAC_DIR
	  echo $MAC > $MAC_PATH
	  sync
	fi

	chmod 775 $MAC_DIR
	chmod 664 $MAC_PATH
fi
